/// <reference types="node" />
import { URL } from 'url';
import { IConnector, NetworkData } from '../../types';
import { JSDOMAsyncHTMLElement, JSDOMAsyncHTMLDocument } from './jsdom-async-html';
import { Sonarwhal } from '../../sonarwhal';
export default class JSDOMConnector implements IConnector {
    private _options;
    private _headers;
    private _request;
    private _server;
    private _href;
    private _finalHref;
    private _targetNetworkData;
    private _window;
    private _document;
    private _fetchedHrefs;
    private _timeout;
    constructor(server: Sonarwhal, config: object);
    private _fetchUrl;
    private traverseAndNotify;
    private resourceLoader;
    private getFavicon;
    collect(target: URL): Promise<{}>;
    close(): Promise<void>;
    fetchContent(target: URL | string, customHeaders?: object): Promise<NetworkData>;
    private killProcess;
    evaluate(source: string): Promise<any>;
    querySelectorAll(selector: string): Promise<Array<JSDOMAsyncHTMLElement>>;
    readonly dom: JSDOMAsyncHTMLDocument;
    readonly headers: object;
    readonly html: Promise<string>;
}
